3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add [-b branch] <repo> <path>]|[status|init|update [-i|--init] [-N|--no-fetch] [--rebase|--merge]|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
24 # print stuff on stdout unless -q was specified
34 # Resolve relative url by appending to parent's url
35 resolve_relative_url ()
37 remote=$(get_default_remote)
38 remoteurl=$(git config "remote.$remote.url") ||
39 die "remote ($remote) does not have a url defined in .git/config"
41 remoteurl=${remoteurl%/}
47 remoteurl="${remoteurl%/*}"
56 echo "$remoteurl/${url%/}"
60 # Get submodule info for registered submodules
61 # $@ = path to limit submodule list
65 git ls-files --error-unmatch --stage -- "$@" | grep '^160000 '
69 # Map submodule path to submodule name
75 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
76 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
77 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
78 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
80 die "No submodule mapping found in .gitmodules for path '$path'"
87 # Prior to calling, cmd_update checks that a possibly existing
88 # path is not a git repository.
89 # Likewise, cmd_add checks that path does not exist at all,
90 # since it is the location of a new submodule.
98 # If there already is a directory at the submodule path,
99 # expect it to be empty (since that is the default checkout
100 # action) and try to remove it.
101 # Note: if $path is a symlink to a directory the test will
102 # succeed but the rmdir will fail. We might want to fix this.
105 rmdir "$path" 2>/dev/null ||
106 die "Directory '$path' exist, but is neither empty nor a git repository"
110 die "A file already exist at path '$path'"
112 if test -n "$reference"
114 git-clone "$reference" -n "$url" "$path"
116 git-clone -n "$url" "$path"
118 die "Clone of '$url' into submodule path '$path' failed"
122 # Add a new submodule to the working tree, .gitmodules and the index
126 # optional branch is stored in global branch variable
130 # parse $args after "submodule ... add".
135 case "$2" in '') usage ;; esac
143 case "$2" in '') usage ;; esac
144 reference="--reference=$2"
168 if test -z "$repo" -o -z "$path"; then
172 # assure repo is absolute or relative to parent
175 # dereference source url relative to parent's url
176 realrepo=$(resolve_relative_url "$repo") || exit
183 die "repo URL: '$repo' must be absolute or begin with ./|../"
188 # multiple //; leading ./; /./; /../; trailing /
189 path=$(printf '%s/\n' "$path" |
199 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
200 die "'$path' already exists in the index"
202 # perhaps the path exists and is already a git repo, else clone it
205 if test -d "$path"/.git -o -f "$path"/.git
207 echo "Adding existing repo at '$path' to the index"
209 die "'$path' already exists and is not a valid git repo"
214 url=$(resolve_relative_url "$repo") || exit
220 git config submodule."$path".url "$url"
223 module_clone "$path" "$realrepo" "$reference" || exit
227 # ash fails to wordsplit ${branch:+-b "$branch"...}
229 '') git checkout -f -q ;;
230 ?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
232 ) || die "Unable to checkout submodule '$path'"
236 die "Failed to add submodule '$path'"
238 git config -f .gitmodules submodule."$path".path "$path" &&
239 git config -f .gitmodules submodule."$path".url "$repo" &&
240 git add .gitmodules ||
241 die "Failed to register submodule '$path'"
245 # Execute an arbitrary command sequence in each checked out
248 # $@ = command to execute
253 while read mode sha1 stage path
255 if test -e "$path"/.git
257 say "Entering '$path'"
258 (cd "$path" && eval "$@") ||
259 die "Stopping at '$path'; script returned non-zero status."
265 # Register submodules in .git/config
267 # $@ = requested paths (default to all)
271 # parse $args after "submodule ... init".
293 while read mode sha1 stage path
295 # Skip already registered paths
296 name=$(module_name "$path") || exit
297 url=$(git config submodule."$name".url)
298 test -z "$url" || continue
300 url=$(git config -f .gitmodules submodule."$name".url)
302 die "No url found for submodule path '$path' in .gitmodules"
304 # Possibly a url relative to parent
307 url=$(resolve_relative_url "$url") || exit
311 git config submodule."$name".url "$url" ||
312 die "Failed to register url for submodule path '$path'"
314 upd="$(git config -f .gitmodules submodule."$name".update)"
316 git config submodule."$name".update "$upd" ||
317 die "Failed to register update mode for submodule path '$path'"
319 say "Submodule '$name' ($url) registered for path '$path'"
324 # Update each submodule path to correct revision, using clone and checkout as needed
326 # $@ = requested paths (default to all)
330 # parse $args after "submodule ... update".
351 case "$2" in '') usage ;; esac
352 reference="--reference=$2"
378 cmd_init "--" "$@" || return
382 while read mode sha1 stage path
384 name=$(module_name "$path") || exit
385 url=$(git config submodule."$name".url)
386 update_module=$(git config submodule."$name".update)
389 # Only mention uninitialized submodules when its
390 # path have been specified
392 say "Submodule path '$path' not initialized" &&
393 say "Maybe you want to use 'update --init'?"
397 if ! test -d "$path"/.git -o -f "$path"/.git
399 module_clone "$path" "$url" "$reference"|| exit
402 subsha1=$(unset GIT_DIR; cd "$path" &&
403 git rev-parse --verify HEAD) ||
404 die "Unable to find current revision in submodule path '$path'"
407 if ! test -z "$update"
409 update_module=$update
412 if test "$subsha1" != "$sha1"
415 if test -z "$subsha1"
420 if test -z "$nofetch"
422 (unset GIT_DIR; cd "$path" &&
424 die "Unable to fetch in submodule path '$path'"
427 case "$update_module" in
439 command="git checkout $force -q"
445 (unset GIT_DIR; cd "$path" && $command "$sha1") ||
446 die "Unable to $action '$sha1' in submodule path '$path'"
447 say "Submodule path '$path': $msg '$sha1'"
456 git describe "$2" 2>/dev/null ||
457 git describe --tags "$2" 2>/dev/null ||
458 git describe --contains "$2" 2>/dev/null ||
459 git describe --all --always "$2"
462 test -z "$revname" || revname=" ($revname)"
465 # Show commit summary for submodules in index or working tree
467 # If '--cached' is given, show summary between index and given commit,
468 # or between working tree and given commit
470 # $@ = [commit (default 'HEAD'),] requested paths (default all)
476 # parse $args after "submodule ... summary".
487 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
509 test $summary_limit = 0 && return
511 if rev=$(git rev-parse -q --verify "$1^0")
520 # Get modified modules cared by user
521 modules=$(git diff-index $cached --raw $head -- "$@" |
522 egrep '^:([0-7]* )?160000' |
523 while read mod_src mod_dst sha1_src sha1_dst status name
525 # Always show modules deleted or type-changed (blob<->module)
526 test $status = D -o $status = T && echo "$name" && continue
527 # Also show added or modified modules which are checked out
528 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
533 test -z "$modules" && return
535 git diff-index $cached --raw $head -- $modules |
536 egrep '^:([0-7]* )?160000' |
538 while read mod_src mod_dst sha1_src sha1_dst status name
540 if test -z "$cached" &&
541 test $sha1_dst = 0000000000000000000000000000000000000000
545 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
547 100644 | 100755 | 120000)
548 sha1_dst=$(git hash-object $name)
554 echo >&2 "unexpected mode $mod_dst"
561 test $mod_src = 160000 &&
562 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
565 test $mod_dst = 160000 &&
566 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
570 case "$missing_src,$missing_dst" in
572 errmsg=" Warn: $name doesn't contain commit $sha1_src"
575 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
578 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
583 if test $mod_src = 160000 -a $mod_dst = 160000
585 range="$sha1_src...$sha1_dst"
586 elif test $mod_src = 160000
592 GIT_DIR="$name/.git" \
593 git log --pretty=oneline --first-parent $range | wc -l
595 total_commits=" ($(($total_commits + 0)))"
599 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
600 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
603 if test $mod_dst = 160000
605 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
607 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
610 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
614 # Don't give error msg for modification whose dst is not submodule
615 # i.e. deleted or changed to blob
616 test $mod_dst = 160000 && echo "$errmsg"
618 if test $mod_src = 160000 -a $mod_dst = 160000
621 test $summary_limit -gt 0 && limit="-$summary_limit"
622 GIT_DIR="$name/.git" \
623 git log $limit --pretty='format: %m %s' \
624 --first-parent $sha1_src...$sha1_dst
625 elif test $mod_dst = 160000
627 GIT_DIR="$name/.git" \
628 git log --pretty='format: > %s' -1 $sha1_dst
630 GIT_DIR="$name/.git" \
631 git log --pretty='format: < %s' -1 $sha1_src
637 if test -n "$for_status"; then
638 echo "# Modified submodules:"
640 sed -e 's|^|# |' -e 's|^# $|#|'
646 # List all submodules, prefixed with:
647 # - submodule not initialized
648 # + different revision checked out
650 # If --cached was specified the revision in the index will be printed
651 # instead of the currently checked out revision.
653 # $@ = requested paths (default to all)
657 # parse $args after "submodule ... status".
682 while read mode sha1 stage path
684 name=$(module_name "$path") || exit
685 url=$(git config submodule."$name".url)
686 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
691 set_name_rev "$path" "$sha1"
692 if git diff-files --quiet -- "$path"
694 say " $sha1 $path$revname"
698 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
699 set_name_rev "$path" "$sha1"
701 say "+$sha1 $path$revname"
706 # Sync remote urls for submodules
707 # This makes the value for remote.$remote.url match the value
708 # specified in .gitmodules.
733 while read mode sha1 stage path
735 name=$(module_name "$path")
736 url=$(git config -f .gitmodules --get submodule."$name".url)
738 # Possibly a url relative to parent
741 url=$(resolve_relative_url "$url") || exit
745 if test -e "$path"/.git
750 remote=$(get_default_remote)
751 say "Synchronizing submodule url for '$name'"
752 git config remote."$remote".url "$url"
758 # This loop parses the command line arguments to find the
759 # subcommand name to dispatch. Parsing of the subcommand specific
760 # options are primarily done by the subcommand implementations.
761 # Subcommand specific options such as --branch and --cached are
762 # parsed here as well, for backward compatibility.
764 while test $# != 0 && test -z "$command"
767 add | foreach | init | update | status | summary | sync)
797 # No command word defaults to "status"
798 test -n "$command" || command=status
800 # "-b branch" is accepted only by "add"
801 if test -n "$branch" && test "$command" != add
806 # "--cached" is accepted only by "status" and "summary"
807 if test -n "$cached" && test "$command" != status -a "$command" != summary